l   = 10;
dia = 20;
d   = 10;
sep = 20;
dik = 10;
$fn = 80;

D2  = 50;
L2  = 50;
H2  = 30;

spiegeldikte = 5;    // adjust for thickness of the mirror

 xcube();            // space for an 18mm xcube 

spiegel();
scale([-1,1,1])spiegel();

translate([  0,L2,0])rotate([0,0,90])ringen();
translate([-D2,L2,0])rotate([0,0,90])ringen();
translate([ D2,L2,0])rotate([0,0,90])ringen();

difference(){
	translate([0, 30,-H2])box(140,100, 6, rad=10);
	translate([ 25,0,0])cylinder(h=100,d=4,center=true);
	translate([-25, 0,0])cylinder(h=100,d=4,center=true);
	translate([ 25,60,0])cylinder(h=100,d=4,center=true);
	translate([-25,60,0])cylinder(h=100,d=4,center=true);
	}

	
	
module xcube(){
	cbe = 20;
	difference(){
	translate([0,0,-dia/4])cube([cbe+4,cbe+4,cbe+4+dia/2],center=true);
	translate([0,0,2.5])cube([cbe,cbe,cbe+5],center=true); 
	
	rotate([0,90,0])cylinder(h=100,d=15,center=true);
	rotate([90,0,0])cylinder(h=100,d=15,center=true);
	}
	}

module spiegel(){
	translate([D2,0,-dia/4])difference(){
		cube([26,26,26+dia/2],center=true);
		translate([-18, 18,dia/2])rotate([0,0,45])translate([0,-spiegeldikte,0])cube([50,50,26+dia/2],center=true);
		translate([-18+30, 18-30,0])rotate([0,0,45])cube([50,3,36+dia/2],center=true);
		
		}
	}
	
module ringen(){
translate([-sep/2,0,0])rotate([0,90,0])ring();
translate([ sep/2,0,0])rotate([0,90,0])ring();
hull(){
	translate([-sep/2,0,-dia/2-dik])cylinder(h=10,d1=20,d2=10);
	translate([-sep/2,0,-dia/2-H2+25-dik])cylinder(h=10,d=20);
	translate([ sep/2,0,-dia/2-dik])cylinder(h=10,d1=20,d2=10);
	translate([ sep/2,0,-dia/2-H2+25-dik])cylinder(h=10,d=20);
	}
}

module ring(){
    difference(){
        cylinder(h=l,d=dia+d,center=true);
        cylinder(h=l, d=dia,center=true);    
    //}{
    
    
        for(i=[0:120:360]){
        rotate([0,0,i+180])translate([dia/2,0,0])rotate([0,90,0]){
                cylinder(h=4.2,d=7.98,center=true,$fn=6);
                translate([0,0,-(dia/2-3.20)])cylinder(h=100,d=4,$fn=80);
                }
            }
        }
	}
	
module box(x,y,z,rad){
    $fn=40;
    xx = x-2*rad;
    yy = y-2*rad;
    translate([rad-x/2,rad-y/2,0])
        hull(){
            translate([ 0, 0, 0])cyl(r=rad,h=z);
            translate([xx, 0, 0])cyl(r=rad,h=z);
            translate([ 0,yy, 0])cyl(r=rad,h=z);
            translate([xx,yy, 0])cyl(r=rad,h=z);
            }
    }
module cyl(r,h){
	cylinder(r1=r,r2=r,h=h-2);
	translate([0,0,h])cylinder(r1=r,r2=r-2,h=2);
	}